/*!
 * @file
 * 
 * @brief Setup L4 opamp1 to buffer DAC Channel 1 in order to drive pin PA3
 * 
 * @author Don Hummels
 * 
 * @date Jan 2016
 * 
 */

#include "stm32l4xx_hal.h"
#include "opamp486.h"

static OPAMP_HandleTypeDef OpampHandle;

// Setup L4 opamp1 to buffer the dac1 output1 in order to drive pin PA3

void opamp_init(void)
{
	OpampHandle.Instance = OPAMP1;
	OpampHandle.Init.Mode = OPAMP_FOLLOWER_MODE; // follower mode
	OpampHandle.Init.NonInvertingInput = OPAMP_NONINVERTINGINPUT_DAC_CH;
        OpampHandle.Init.UserTrimming = OPAMP_TRIMMING_FACTORY;
	HAL_OPAMP_Init(&OpampHandle);

        HAL_OPAMP_Start(&OpampHandle);
	return;
}


void HAL_OPAMP_MspInit(OPAMP_HandleTypeDef * opamp)
{
	GPIO_InitTypeDef GPIO_InitStruct;

	__HAL_RCC_GPIOA_CLK_ENABLE();
	__HAL_RCC_OPAMP_CLK_ENABLE();

	GPIO_InitStruct.Pin = GPIO_PIN_3;
	GPIO_InitStruct.Mode = GPIO_MODE_ANALOG;
	GPIO_InitStruct.Pull = GPIO_NOPULL;
	HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);

}
